
/****************************************************************************
 *
 *	$RCSfile: wsockerr.cpp $
 *	$Author: tim $
 *	$Date: 1998/01/21 23:12:23 $
 *	$Revision: 1.1 $
 *
 *	Originator:
 *		Tim Foden
 *
 *	Description:
 *		TBA
 *
 ****************************************************************************/

#include <windows.h>

#include "wsockerr.h"

const char* GetWSAErrorString( DWORD error )
{
    switch( error )
    {
        /*
         * Windows Sockets definitions of regular Microsoft C error constants
         */
        case WSAEINTR:              return "Interrupt";
        case WSAEBADF:              return "Bad file";
        case WSAEACCES:             return "Access denied";
        case WSAEFAULT:             return "Fault";
        case WSAEINVAL:             return "Invalid";
        case WSAEMFILE:             return "MFILE (?)";

        /*
         * Windows Sockets definitions of regular Berkeley error constants
         */
        case WSAEWOULDBLOCK:        return "Would block";
        case WSAEINPROGRESS:        return "In progress";
        case WSAEALREADY:           return "Already";
        case WSAENOTSOCK:           return "Not a socket";
        case WSAEDESTADDRREQ:       return "Destination address required";
        case WSAEMSGSIZE:           return "Message size";
        case WSAEPROTOTYPE:         return "Protocol type";
        case WSAENOPROTOOPT:        return "Protocol option";
        case WSAEPROTONOSUPPORT:    return "Protocol not supported";
        case WSAESOCKTNOSUPPORT:    return "Socket type not supported";
        case WSAEOPNOTSUPP:         return "Option not supported";
        case WSAEPFNOSUPPORT:       return "Protocol family not supported";
        case WSAEAFNOSUPPORT:       return "Address family not supported";
        case WSAEADDRINUSE:         return "Address in use";
        case WSAEADDRNOTAVAIL:      return "Address not available";
        case WSAENETDOWN:           return "Network down";
        case WSAENETUNREACH:        return "Network unreachable";
        case WSAENETRESET:          return "Network reset";
        case WSAECONNABORTED:       return "Connection aborted";
        case WSAECONNRESET:         return "Connection reset";
        case WSAENOBUFS:            return "No buffers";
        case WSAEISCONN:            return "Is connected";
        case WSAENOTCONN:           return "Not connected";
        case WSAESHUTDOWN:          return "Shutdown";
        case WSAETOOMANYREFS:       return "Too many REFS";
        case WSAETIMEDOUT:          return "Timed out";
        case WSAECONNREFUSED:       return "Connection refused";
        case WSAELOOP:              return "Loop";
        case WSAENAMETOOLONG:       return "Name too long";
        case WSAEHOSTDOWN:          return "Host down";
        case WSAEHOSTUNREACH:       return "Host unreachable";
        case WSAENOTEMPTY:          return "Not empty";
        case WSAEPROCLIM:           return "PROCLIM";
        case WSAEUSERS:             return "USERS";
        case WSAEDQUOT:             return "DQUOT";
        case WSAESTALE:             return "Stale";
        case WSAEREMOTE:            return "Remote";

        case WSAEDISCON:            return "Disconnected";

        /*
         * Extended Windows Sockets error constant definitions
         */
        case WSASYSNOTREADY:        return "System not ready";
        case WSAVERNOTSUPPORTED:    return "Version not supported";
        case WSANOTINITIALISED:     return "Not initialised";
    }

    return 0;
}
